"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@mdx-js/react");

const {
  useInput,
  useInputByKey
} = require(`../renderer/input-provider`);

const {
  useResource
} = require(`../renderer/resource-provider`);

const {
  useProvider
} = require(`../renderer/provider-provider`);

const transformRecipeMDX = require(`../transform-recipe-mdx`);

const transformCodeForEval = jsx => `${jsx}

  return React.createElement(MDXProvider, { components },
    React.createElement(MDXContent, props)
  );`;

var _default = ({
  children: mdxSrc,
  scope,
  components,
  ...props
}) => {
  const fullScope = {
    mdx: _react2.mdx,
    MDXProvider: _react2.MDXProvider,
    React: _react.default,
    components,
    props,
    useInput,
    useInputByKey,
    useResource,
    useProvider,
    ...scope
  };
  const scopeKeys = Object.keys(fullScope);
  const scopeValues = Object.values(fullScope);
  const srcCode = transformRecipeMDX(mdxSrc);
  const fn = new Function(...scopeKeys, transformCodeForEval(srcCode)); // console.log(srcCode)

  return fn(...scopeValues);
};

exports.default = _default;